#include <stdio.h>
#include <stdlib.h>

#include "cpu.h"

#include <ctype.h>
#include <time.h>
/* ֐錾 */
int select_last( int his, int prev_move, int *move );

/* O[oϐ` */
int board[SIZE][SIZE];    /* WsW */
int first_value = 0;
int last_value = 0;
int depth = 3;            /* ǂ݂̎萔(default) */

/* 萔` */
#define TRUE  1
#define FALSE 0
#define SIZE  8
#define FIRST 0
#define LAST  1
#define RSIZE 256  /* [hobt@TCY */
#define NO_LINE (-1)
#define NO_VALUE  10000
#define MAX_VALUE 1000
#define MIN_VALUE (-1000)

/* }N */
#define GET_X( c )      ((c)>> 8)
#define GET_Y( c )      ((c) & 0xff)
#define MAKE_XY( x, y ) (((x) << 8) + (y))













/****** vl[` ******/



	/* vl[` */
	Pos p;


/* I̕]l */
int finish_value( void )
{
  if( first_value > last_value ){
    /* ̏ */
    return MAX_VALUE + first_value - last_value;
  } else if( first_value < last_value ){
    /* ̏ */
    return MIN_VALUE + first_value - last_value;
  } else {
    /*  */
    return 0;
  }
}

/* Ĩ`FbN */
int check_finish( int x, int y )
{
  int i, xf = 0, yf = 0;
  /* cAŐȂ */
  for( i = 0; i < SIZE; i++ ){
    if( board[x][i] != NO_VALUE ) xf = 1;
    if( board[i][y] != NO_VALUE ) yf = 1;
  }
  if( xf == 0 || yf == 0 ) return TRUE;
  return FALSE;
}


/* ̑I */
int select_first( int his, int prev_move, int *move )
{
  if( his == depth ){
    /* ǂݏI */
    return first_value - last_value;
  } else {
    int x;
    int py = GET_Y( prev_move );
    int value = NO_VALUE;
    /* ͉ */
    for( x = 0; x < SIZE; x++ ){
      if( board[x][py] != NO_VALUE ){
        int v;
        int m;
        int save_board = board[x][py];
        int save_value = first_value;
        first_value += board[x][py];
        board[x][py] = NO_VALUE;
        if( check_finish( x, py ) ){
          /* I */
          v = finish_value();
        } else {
          /*  */
          v = select_last( his + 1, MAKE_XY( x, py ), &m );
        }
        /* Pȃ~j}bNX -- 傫I */
        if( value == NO_VALUE || v > value ){
          value = v;
          *move = MAKE_XY( x, py );
        }
        /* Ֆʂɖ߂ */
        board[x][py] = save_board;
        first_value = save_value;
      }
    }
    return value;
  }
}

/* ̑I */
int select_last( int his, int prev_move, int *move )
{
  if( his == depth ){
    /* ǂݏI */
    return first_value - last_value;
  } else {
    int y;
    int px = GET_X( prev_move );
    int value = NO_VALUE;
    /* ͏c */
    for( y = 0; y < SIZE; y++ ){
      if( board[px][y] != NO_VALUE ){
        int v;
        int m;
        int save_board = board[px][y];
        int save_value = last_value;
        last_value += board[px][y];
        board[px][y] = NO_VALUE;
        if( check_finish( px, y ) ){
          /* I */
          v = finish_value();
        } else {
          /*  */
          v = select_first( his + 1, MAKE_XY( px, y ), &m );
        }
        /* Pȃ~j}bNX -- I */
        if( value == NO_VALUE || v < value ){
          value = v;
          *move = MAKE_XY( px, y );
        }
        /* Ֆʂɖ߂ */
        board[px][y] = save_board;
        last_value = save_value;
      }
    }
    return value;
  }
}



/********************************************************/
/* 2܂œǂ݂܂ */
/* 肪鐔łȂȂ悤Ȏ */

/* Ԃ̂ƂłꏊƐԂ֐ */
static Pos GetMax(int [][SIZE], int); 

Pos p1127goto(int State[][SIZE], int Turn)
{
	int i,j,k; /* [vɎgp */
	int num; 
	int min; /* 肪l̍ŏl */
	Pos p;  /* vl[`ԂꏊƐ */

	Pos one[64];  /* 1łƂꏊƐۑz */

	/* 1łƂꏊ𒲂ׂ */
	k=0;
	for(i=0; i<SIZE; i++){
		for(j=0; j<SIZE; j++){
			num = Num_of_othello(State, Turn, i,j,NULL);
			if( num > 0 ){
				/* 1łƂꏊƐׂċLĂ */
				one[k].x = i; one[k].y = j;
				one[k].get = num;
				k++;
			}
		}
	}

	/* ǂɒuĂƂȂꍇ */
	/* (ƂꏊSۑĂȂꍇ k0̂܂) */
	if(k == 0){
		p.x = -1;
		p.y = -1;
		p.get = 0;
		return p;
	}


	/* 2ڂǂ
	   ͒PɈԂƂƂė
	   Ɖ肷 */
	min = 100; /* ŏl100ɂĂ */
	/* SĂ1(ĹBkނ)ɕtčl */
	for(i=0; i<k; i++){
		int **PseudoState1; /* 1ڂ̏Ԃ߂Ƃ̃|C^ */
		int PState1[SIZE][SIZE]; /* 1ڂł̏Ԃێ */
		int tr = Turn;     /* ǂ݂Ƃ̎ԕϐ */
		int x, y;
		Pos p1;  /* 肪łėꏊ */

		x = one[i].x;
		y = one[i].y;
		/* 1ڂł */
		/* ł̔Ֆʂ */
		PseudoState1 = Put_othello(State, tr, x,y);
		PseudoState1[x][y] = tr;
		/* Rs[ */
		CopyState(PseudoState1, PState1);
		/* Rs[Rs[͔j */
		freeState(PseudoState1);
		/* ^[ς */
		tr *= -1;

		/* 1ڂł̏Ԃ
		   łƂT
		   (̔) */
		p1 = GetMax(PState1, tr);

		/* 肪鐔菭Ȃ
		   ̂Ƃ1ڂ̗p */
		if(p1.get < min){ 
			p.x = x;
			p.y = y;
			p.get = one[i].get;
			min = p1.get;
		} else
			/* 肪鐔ꏏȂ
		   	炪葽قI */
		if(p1.get == min && p.get < one[i].get){
			p.x = x;
			p.y = y;
			p.get = one[i].get;
		}
	}

	return p;
}

/* ԂƎԂ̂ƂAłƂT֐ */
static Pos GetMax(int PState[][SIZE], int tr)
{
	int i,j;
	int num; /* 鐔 */
	int max; /* ől */
	Pos p;   /* Ԃꏊ */

	max = 0;
	for(i=0; i<SIZE; i++){
		for(j=0; j<SIZE; j++){
			num = Num_of_othello(PState, tr, i, j, NULL);
			if(num >= max){
				max = num;
				p.x = i;
				p.y = j;
				p.get = max;
			}
		}
	}

	/* ǂȂꍇ(-1,-1)Ԃ */
	if(max == 0){
		p.x = -1;
		p.y = -1;
		p.get = 0;
	}

       


	return p;
}





















