#include <stdio.h>
#include <stdlib.h>

#include "cpu.h"

Pos p1173yosh(int State[][SIZE], int Turn)
{
    int i, j, k = 0;
    int num;
    int min = 64;
    Pos Opponent(int [][SIZE], int);
    Pos p;
    Pos one[64];

    int **PseudoState1;
    int PState1[SIZE][SIZE];
    int tr = Turn;
    int x, y;
    Pos p1;
    int flag = 0;

    for(i=0; i<SIZE; i++){
        for(j=0; j<SIZE; j++){
	    num = Num_of_othello(State, Turn, i, j, NULL);
	    /* pDIɎ */
	    if(i==0 && j==0 && num>0){
	        p.x = 0;
		p.y = 0;
		p.get = num;
		printf("x=%d y=%d\n", p.x, p.y);
		return p;
	    } else if(i==0 && j==7 && num>0){
	        p.x = 0;
		p.y = 7;
		p.get = num;
		printf("x=%d y=%d\n", p.x, p.y);
		return p;
	    } else if(i==7 && j==0 && num>0){
	        p.x = 7;
		p.y = 0;
		p.get = num;
		printf("x=%d y=%d\n", p.x, p.y);
		return p;
	    } else if(i==7 && j==7 && num>0){
	        p.x = 7;
		p.y = 7;
		p.get = num;
		printf("x=%d y=%d\n", p.x, p.y);
		return p;
		/* {IɊp̑ɂ͒uȂ */
	    } else if((State[0][0]!=0 ||
		       ((i!=0 || j!=1) &&
		        (i!=1 || j!=0) &&
		        (i!=1 || j!=1))) &&
		      (State[7][0]!=0 ||
		       ((i!=6 || j!=0) &&
			(i!=6 || j!=1) &&
			(i!=7 || j!=1))) &&
		      (State[0][7]!=0 ||
		       ((i!=0 || j!=6) &&
			(i!=1 || j!=6) &&
			(i!=1 || j!=7))) &&
		      (State[7][7]!=0 ||
		       ((i!=6 || j!=6) &&
			(i!=6 || j!=7) &&
			(i!=7 || j!=6))) && num>0){
	        one[k].x = i;
		one[k].y = j;
		one[k].get = num;
		k++;
	    }
	}
    }

    /* \\h1 */
    if(k==0){
        for(i=0; i<SIZE; i++){
	    for(j=0; j<SIZE; j++){
	        num = Num_of_othello(State, Turn, i, j, NULL);
		if(num>0){
		    one[k].x = i;
		    one[k].y = j;
		    one[k].get = num;
		    k++;
		}
	    }
	}
    }

    /* uȂ΃pX */
    if(k==0){
        p.x = -1;
	p.y = -1;
	p.get = 0;
	printf("x=%d y=%d\n", p.x, p.y);
	return p;
    }

    /* ڂǂ */
    for(i=0; i<k; i++){
	x = one[i].x;
	y = one[i].y;
	PseudoState1 = Put_othello(State, Turn, x, y);
	PseudoState1[x][y] = Turn;
	CopyState(PseudoState1, PState1);
	freeState(PseudoState1);
	tr = -1*Turn;

	p1 = Opponent(PState1, tr);
	
	/* p͑I΂Ȃ */
	if(p1.get==-1) continue;
	if(p1.get<min){
	    p.x = x;
	    p.y = y;
	    p.get = one[i].get;
	    min = p1.get;
	    flag = 1;
	} else if(p1.get==min && p.get<one[i].get){
	    p.x = x;
	    p.y = y;
	    p.get = one[i].get;
	}
    }

    /* \\h2 */
    if(flag==0){
        for(i=0; i<k; i++){
	    x = one[i].x;
	    y = one[i].y;
	    PseudoState1 = Put_othello(State, Turn, x, y);
	    PseudoState1[x][y] = Turn;
	    CopyState(PseudoState1, PState1);
	    freeState(PseudoState1);
	    tr = -1*Turn;
	    
	    p1 = Opponent(PState1, tr);
	    
	    if(p1.get<min){
	        p.x = x;
		p.y = y;
		p.get = one[i].get;
		min = p1.get;
	    } else if(p1.get==min && p.get<one[i].get){
	        p.x = x;
		p.y = y;
		p.get = one[i].get;
	    }
	}
    }
    printf("x=%d y=%d\n", p.x, p.y);
    return p;
}

Pos Opponent(int PState[][SIZE], int tr)
{
    int i, j;
    int num;
    int max = 0;
    Pos p;

    for(i=0; i<SIZE; i++){
        for(j=0; j<SIZE; j++){
	    num = Num_of_othello(PState, tr, i, j, NULL);
	    if(i==0 && j==0 && num>0){
	        p.x = 0;
		p.y = 0;
		p.get = -1;
		return p;
	    } else if(i==0 && j==7 && num>0){
	        p.x = 0;
		p.y = 7;
		p.get = -1;
		return p;
	    } else if(i==7 && j==0 && num>0){
	        p.x = 7;
		p.y = 0;
		p.get = -1;
		return p;
	    } else if(i==7 && j==7 && num>0){
	        p.x = 7;
		p.y = 7;
		p.get = -1;
		return p;
	    } else if(num>=max){
	        max = num;
		p.x = i;
		p.y = j;
		p.get = max;
	    }
	}
    }

    if(max==0){
        p.x = -1;
	p.y = -1;
	p.get = 0;
    }
    return p;
}
