#include <stdio.h>
#include <stdlib.h>

#include "cpu.h"
#define BEGIN_LIMIT 5
#define MIDDLE_LIMIT 7
#define END_LIMIT 9
#define FALSE -999

#define PERIOD1 17 //Kǂ
#define PERIOD2 23 //Sǂ

#define WIN 1
#define DRAW 0
#define LOSE -1

//֐錾
int maxlevel(int State[SIZE][SIZE], int Turn, int turn_count, int LIMIT, int limit, Pos *p, int beta);
int minlevel(int State[SIZE][SIZE], int Turn, int turn_count, int LIMIT, int limit, Pos *p, int alpha);
//w肳ꂽF(Turn)̐΂̐𐔂
int count(int State[SIZE][SIZE], int Turn);
//w肳ꂽF̐(Turn)̕]l𐔂
int value_count(int State[SIZE][SIZE], int Turn);

static int Mvalue[SIZE][SIZE] ={
	{100, 1, 20, 6, 6, 20, 1,100},
	{ 1, -20, 4, 4, 4, 4, -20, 1},
	{ 20, 4, 5, 1, 1, 5, 4, 20},
	{ 6, 4, 1, 1, 1, 1, 4, 6},
	{ 6, 4, 1, 1, 1, 1, 4, 6},
	{ 20, 4, 5, 1, 1, 5, 4, 20},
	{ 1, -20, 4, 4, 4, 4, -20, 1},
	{100, 1, 20, 6, 6, 20, 1,100}};

Pos p4212tera(int State[][SIZE], int Turn)
{
  Pos p;
  int beta = 999;
  static int turn_count=0;
  int LIMIT;
  
  //ǂގ萔̐ݒ
  if( turn_count < PERIOD1 ){
    LIMIT = BEGIN_LIMIT;
  }else if( turn_count < PERIOD2){
    LIMIT = MIDDLE_LIMIT;
  }else{
    LIMIT = END_LIMIT;
  }
   
  maxlevel(State, Turn, turn_count, LIMIT, LIMIT, &p, beta);
  
  turn_count++;//萔𐔂

  return p;  
}

int maxlevel(int State[SIZE][SIZE], int Turn, int turn_count, int LIMIT, int limit, Pos *p, int beta)
{ 
  int score, score_max = -999;
  int alpha = -999;
  int point;
  int i,j,k;
  int num;
  Pos one[64];

  //[̐
  if(limit == 0){  
    //]lԂ
    point = value_count(State, Turn) -  value_count(State, Turn*(-1));

    return point;
  }

  //Ƃꏊ𒲂ׂ
  for(i=0,k=0; i<SIZE; i++){
    for(j=0; j<SIZE; j++){
      num = Num_of_othello(State, Turn, i, j, NULL);
      if( num > 0 ){
	one[k].x = i; 
	one[k].y = j;
	one[k].get = num;
	k++;
      }
    }
  }
  
  //ǂɒuĂƂȂꍇ
  if( k==0 ){
    if(limit == LIMIT){
      (*p).x = -1;
      (*p).y = -1;
      (*p).get = 0;
    }
    
    //]lԂ
    point = value_count(State, Turn) - value_count(State, Turn*(-1));

    return point;
  }

  for(i=0; i<k; i++){
    int **PseudoState;
    int PState[SIZE][SIZE];
    int x,y,get;

    x = one[i].x;
    y = one[i].y;
    get = one[i].get;

    //ł̔Ֆʂ
    PseudoState = Put_othello(State, Turn, x, y);
    PseudoState[x][y] = Turn;

    //Rs[
    CopyState(PseudoState, PState);
    //Rs[Rs[͔j
    freeState(PseudoState);
    
    score = minlevel(PState, Turn*(-1), turn_count, LIMIT, limit-1, p, alpha);
    
    if( beta < score ){
      return score;
    }else if( score > score_max ){
      score_max = score;//ǂ肪t
      alpha = score;
      if(limit == LIMIT){
        (*p).x = x;
        (*p).y = y;
        (*p).get = get;
      }
    }
  }

  return score_max;
}

int minlevel(int State[SIZE][SIZE], int Turn, int turn_count, int LIMIT, int limit, Pos *p, int alpha)
{
  int score, score_min = 999;
  int beta = 999;
  int point;
  int i,j,k;
  int num;
  Pos one[64];

  //[̐
  if(limit == 0){
    //]lԂ
    int tmp_point;
    tmp_point = count(State, Turn);
    if( tmp_point == 0 ){//SłƂD悷
      point = 999;
    }else{
      point = value_count(State, Turn*(-1)) - value_count(State, Turn);
    }
    return point;
  }

  //Ƃꏊ𒲂ׂ
  for(i=0,k=0; i<SIZE; i++){
    for(j=0; j<SIZE; j++){
      num = Num_of_othello(State, Turn, i, j, NULL);
      if( num > 0 ){
	one[k].x = i; 
	one[k].y = j;
	one[k].get = num;
	k++;
      }
    }
  }
  
  //ǂɒuĂƂȂꍇ
  if( k==0 ){
    if( limit == LIMIT ){
      (*p).x = -1;
      (*p).y = -1;
      (*p).get = 0;
    }

    //]lԂ
    point = value_count(State, Turn*(-1)) - value_count(State, Turn);

    return point;
  }

  for(i=0; i<k; i++){
    int **PseudoState;
    int PState[SIZE][SIZE];
    int x,y,get;

    x = one[i].x;
    y = one[i].y;
    get = one[i].get;

    //ł̔Ֆʂ
    PseudoState = Put_othello(State, Turn, x, y);
    PseudoState[x][y] = Turn;

    //Rs[
    CopyState(PseudoState, PState);
    //Rs[Rs[͔j
    freeState(PseudoState);
    
    score = maxlevel(PState, Turn*(-1), turn_count, LIMIT, limit-1, p, beta);

    if( alpha > score ){
      return score;
    }else if( score < score_min ){
      score_min = score;//ǂ肪t
      beta = score;
      if(limit == LIMIT){
        (*p).x = x;
	(*p).y = y;
	(*p).get = get;
      }
    }
  }

  return score_min;
} 

//w肳ꂽF(Turn)̐΂̐𐔂
int count(int State[SIZE][SIZE], int Turn)
{
  int i,j;
  int count=0;

  for(i=0; i<SIZE; i++){
    for(j=0; j<SIZE; j++){
      if(State[i][j] == Turn){
	count++;      
      }
    }
  }
  return count;
}
//w肳ꂽF̐(Turn)̕]l𐔂
int value_count(int State[SIZE][SIZE], int Turn)
{
  int i,j;
  int count=0;

  for(i=0; i<SIZE; i++){
    for(j=0; j<SIZE; j++){
      if(State[i][j] == Turn){
	//count++;      
	count += Mvalue[i][j];
      }
    }
  }
  return count;
}
