#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

#include "cpu.h"

/* fobO[h */
/* #define DEBUG */

/* s{ӂȂAȗ[h */
/* #define SHOURYAKU */

typedef int BOOL;
#define  TRUE   1
#define  FALSE  0

typedef int THINK1;  /* ǂݏ(]|Cgt) */
#define  OnlyPuttable      1      /* u邾 */
#define  IsCorner          10000  /* p */
#define  IsInSmallSquare   10     /* 44}X */
#define  IsBesideCorner    -100   /* p̂ƂȂ */

typedef int THINK2;  /* ǂݏ(]|Cgt) */
#define  eOnlyPuttable     -1      /* u邾 */
#define  Corner            -10000  /* p */
#define  OnlyBesideCorner  50      /* p̂ƂȂ肵Ȃ */

#define  PTHINK3  10000  /* think3̕]|Cg */

#define NPPOINT 10

typedef struct tagSTATE {
  int x,y,get;
  int npget;  /* ԂȂ_邩 */
  THINK1 think1;  /* ǂ݂ɂ */
  int egetmax;  /* G̎ő吔 */
  int enpgetmax;  /* G̎ԂȂ_̍ő吔 */
  THINK2 think2;  /* ǂ݂ɂ */
  BOOL think3Corner;  /* ̔ԂŕKp邩(Oǂݏ) */
  Pos rpos[64];  /* Ԃ|Cg */
  Pos rnrpos[64];  /* ΕԂȂ|Cg */
  int rnrposindex;  /* ̃CfbNX */
} STATE;

void PickUpPuttablePos(int State[][SIZE], int Turn, STATE *pos);
void AnalyzePos(int State[][SIZE], int Turn, STATE *pos);
Pos SelectBestPos(STATE *pos);
void UpdateNRmap(STATE *pos);

BOOL Think1(int State[][SIZE], int Turn, STATE *pos);  /* ǂ */
BOOL Think2(int State[][SIZE], int Turn, STATE *pos);  /* ǂ */
BOOL Think3(int State[][SIZE], int Turn, STATE *pos);  /* Oǂ݁ApȂTRUE */

/* ꏊ */
BOOL IsCornerex(const STATE pos);
BOOL IsBesideCornerex(const STATE pos);
BOOL IsInSmallSquareex(const STATE pos);
BOOL IsCornerorg(int x, int y);
BOOL IsBesideCornerorg(int x, int y);
BOOL IsInSmallSquareorg(int x, int y);

/* ֐ */
void StateArrayInitialize(STATE *pos);
void PosArrayInitialize(Pos *pos);

/* G}bv(΂ɕԂȂ|Cgo^}bv) */
#define  MSIZE  SIZE+2
int nrmap[MSIZE][MSIZE];

/* G}bv֌W̊֐ */
void NRInitialize(int **map);  /*  */
void NRCopy(int s[MSIZE][MSIZE], int **c);  /* Rs[ */
BOOL IsNR(int **nrmapbuf, int x, int y);  /* G|Cg */
void RecheckNRmap(int **nrmapbuf, int State[][SIZE], int Turn, STATE *pos);  /* Ֆʂɑ΂ĖG|Cgă`FbN */

/* fobOp */
char *DecodeState(int id);
void DumpNRmap(int **map);
void ddprintf(char *str, int i);

Pos p1121kano(int State[][SIZE], int Turn)
{
  /* vl[` */

    Pos p;   /* ꏊ */

    STATE puttable[64];  /* ꏊi[ */

    ddprintf("\n@@@@ now his no = %d @@@@\n\n",now_his_no);

    /* STATEz̏ */
    ddprintf(" @ StateArrayInitializeTest\n",-1);
    StateArrayInitialize(puttable);

    /* G}bv */
    ddprintf(" @ NRInitializeTest\n",-1);
    NRInitialize((int **)nrmap);

    /* uꏊ𒲂ׂ */
    ddprintf(" @ PickUpPuttablePosTest\n",-1);
    PickUpPuttablePos(State, Turn, puttable);

    /* eꏊɂĉ͂ */
    ddprintf(" @ AnalyzePosTest\n",-1);
    AnalyzePos(State, Turn, puttable);

    /* xXgȃ|CgI */
    ddprintf(" @ SelectBestPosTest\n",-1);
    p = SelectBestPos(puttable);

    return p;
}

void PickUpPuttablePos(int State[][SIZE], int Turn, STATE *pos)
{
    /* uꏊsbNAbv */
    /* Pos̔z̍Ō̗vfɂ-1Ă */

    int i, index = 0, j, num = 0;

    /* SẴ}XɂĒׂ */
    for(i=0; i<SIZE; i++){
     	for(j=0; j<SIZE; j++){
	    /* (i,j)ɑł炢? */
	  num = Num_of_othello(State, Turn, i, j, pos[index].rpos);
	       	/* uȂۑ */
	  if( num > 0 ){
	    pos[index].x = i;
	    pos[index].y = j;
	    pos[index].get = num;
	    index++;
	    ddprintf("pos.x = %d  ",i+1);
	    ddprintf("pos.y = %d  \n",j+1);
	  }
	}
    }
    pos[index].x = -1;
    pos[index].y = -1;
    pos[index].get = 0;
}

void AnalyzePos(int State[][SIZE], int Turn, STATE *pos)
{
    /* eꏊɂď󋵂͂ */
    int i;
    int value, count=0; /* fobOp */

    for(i = 0; pos[i].x != -1; i++){
      /* ꏊɉ */
      ddprintf("Think1 %d start---------------\n",++count);
      Think1(State, Turn, &pos[i]);
      ddprintf("Think1 %d end=================\n",count);

      Think2(State, Turn, &pos[i]);

      value = pos[i].get + pos[i].npget * NPPOINT - pos[i].egetmax - pos[i].enpgetmax * NPPOINT + pos[i].think1 + pos[i].think2
	+ pos[i].think3Corner * PTHINK3;
      printf("x = %d y = %d value = %d\n",pos[i].x + 1,pos[i].y + 1, value);
    } 
}

Pos SelectBestPos(STATE *pos)
{
    Pos rp;
    STATE rs = pos[0];
    int value, maxvalue = -1000000;
    int i;
    STATE p;
    char *code1, *code2;

    for(i = 0; pos[i].x != -1; i++){
      /* ]|Cg̘a߁Aԓ_̍̂̂I */
      p = pos[i];
      value = p.get + p.npget * NPPOINT - p.egetmax - p.enpgetmax * NPPOINT
	+ p.think1 + p.think2 + p.think3Corner * PTHINK3;
      if(value > maxvalue){
	rs = pos[i];
	maxvalue = value;
      }
    } 
    code1 = (char *)DecodeState((int)rs.think1);
    code2 = (char *)DecodeState((int)rs.think2);
    printf("selected pos x = %d y = %d value = %d \nthink1 = %s think2 = %s\n",rs.x + 1, rs.y + 1, maxvalue, code1, code2);
    printf("get = %d  npget = %d\n",rs.get, rs.npget);

    rp.x = rs.x;
    rp.y = rs.y;
    rp.get = rs.get;
    UpdateNRmap(&rs);

    return rp;
}

void UpdateNRmap(STATE *pos)
{
    int i;

    for(i=0; i<pos->rnrposindex; i++)
	nrmap[pos->rnrpos[i].x+1][pos->rnrpos[i].y+1] = 1;
    pos->npget = pos->rnrposindex;
}

BOOL Think1(int State[][SIZE], int Turn, STATE *pos)
{
    int **nrmapbuf;
    int i;

    ddprintf("test0\n",-1);

    /* G}bvobt@̓Im */
    nrmapbuf = (int **)calloc(MSIZE, sizeof(int *));
    for(i=0;i<MSIZE;i++) nrmapbuf[i] = (int *)calloc(MSIZE, sizeof(int));

    ddprintf("test1\n",-1);

    if(IsCornerex(*pos)) { pos->think1 = IsCorner ; }
    else if(IsBesideCornerex(*pos)) { if(now_his_no<32) pos->think1 = IsBesideCorner ; }
    else if(IsInSmallSquareex(*pos)) { pos->think1 = IsInSmallSquare ; }
    else { pos->think1 = OnlyPuttable ; }

    ddprintf("test2\n",-1);

    NRCopy(nrmap, nrmapbuf);
    if(IsNR(nrmapbuf, pos->x, pos->y)) {
      pos->rnrpos[pos->rnrposindex].x = pos->x;
      pos->rnrpos[pos->rnrposindex].y = pos->y;
      pos->rnrposindex++;
	ddprintf("test321\n",-1);
      RecheckNRmap(nrmapbuf, State, Turn, pos);
	ddprintf("test331\n",-1);
    }

    ddprintf("test3\n",-1);

    for(i=0; pos->rpos[i].x!=-1 && i < 64; i++) {

	ddprintf("test31 %d\n",i);

      if(IsNR(nrmapbuf, pos->rpos[i].x, pos->rpos[i].y)) {

	ddprintf("test32\n",-1);

	pos->rnrpos[pos->rnrposindex].x = pos->rpos[i].x;
	pos->rnrpos[pos->rnrposindex].y = pos->rpos[i].y;
	pos->rnrposindex++;

	ddprintf("test33\n",-1);

	RecheckNRmap(nrmapbuf, State, Turn, pos);

	ddprintf("test34\n",-1);
      }
    }

    ddprintf("test35\n",-1);
    DumpNRmap(nrmapbuf);

    pos->npget = pos->rnrposindex;

    ddprintf("test4\n",-1);

    for(i=0;i<MSIZE;i++) free(nrmapbuf[i]), nrmapbuf[i] = 0;
    free(nrmapbuf); nrmapbuf = 0;

    return TRUE ;
}

BOOL Think2(int State[][SIZE], int Turn, STATE *pos)
{
    int **PseudoState1; /* 1ڂ̏Ԃ߂Ƃ̃|C^ */
    int PState1[SIZE][SIZE]; /* 1ڂł̏Ԃێ */
    int tr = Turn;     /* ǂ݂Ƃ̎ԕϐ */
    int i,j,num;
    STATE posbuf;
    
    pos->egetmax = 0;
    pos->think2 = OnlyBesideCorner;
    pos->think3Corner = TRUE;

    /* 1ڂł */
    /* ł̔Ֆʂ */
    PseudoState1 = Put_othello(State, tr, pos->x, pos->y);
    PseudoState1[pos->x][pos->y] = tr;
    /* Rs[ */
    CopyState(PseudoState1, PState1);
    /* Rs[Rs[͔j */
    freeState(PseudoState1);
    /* ^[ς */
    tr *= -1;
    
    for(i=0; i<SIZE; i++) {
      for(j=0; j<SIZE; j++) {
	/* (i,j)ɑł炢? */
	num = Num_of_othello(PState1, tr, i, j, NULL);
	if( num ){
	  if(num >= pos->egetmax) pos->egetmax = num;
	  if(IsCornerorg(i,j)) pos->think2 = Corner;
	  if(!IsBesideCornerorg(i,j) && pos->think2 == OnlyBesideCorner)
	    pos->think2 = eOnlyPuttable;
	  posbuf.x = i;
	  posbuf.y = j;
	  posbuf.get = num;
	  if(!Think3(PState1, tr, &posbuf)) pos->think3Corner = FALSE;
	}
      }
    }

    pos->enpgetmax = 0;

    return TRUE;
}

BOOL Think3(int State[][SIZE], int Turn, STATE *pos)
{
    int **PseudoState1; /* 1ڂ̏Ԃ߂Ƃ̃|C^ */
    int PState1[SIZE][SIZE]; /* 1ڂł̏Ԃێ */
    int tr = Turn;     /* ǂ݂Ƃ̎ԕϐ */
    int i,j,num;
    
    pos->think3Corner = TRUE;

    /* 1ڂł */
    /* ł̔Ֆʂ */
    PseudoState1 = Put_othello(State, tr, pos->x, pos->y);
    PseudoState1[pos->x][pos->y] = tr;
    /* Rs[ */
    CopyState(PseudoState1, PState1);
    /* Rs[Rs[͔j */
    freeState(PseudoState1);
    /* ^[ς */
    tr *= -1;

    for(i=0; i<SIZE; i++) {
      for(j=0; j<SIZE; j++) {
	/* (i,j)ɑł炢? */
	num = Num_of_othello(State, Turn, i, j, NULL);
	if( num ){
	  if(IsCornerorg(i,j)) return TRUE;
	}
      }
    }
    return FALSE;
}
     
BOOL IsCornerex(const STATE pos)
{
    return IsCornerorg(pos.x, pos.y);
}

BOOL IsBesideCornerex(const STATE pos)
{
    return IsBesideCornerorg(pos.x, pos.y);
}

BOOL IsInSmallSquareex(const STATE pos)
{
    return IsInSmallSquareorg(pos.x, pos.y);
}

BOOL IsCornerorg(int x, int y)
{
    if(   (x == 0 && y == 0)
       || (x == 0 && y == 7) 
       || (x == 7 && y == 0) 
       || (x == 7 && y == 7)  )
      return TRUE;
    return FALSE;
}

BOOL IsBesideCornerorg(int x, int y)
{
    if(   (x == 0 && y == 1)
       || (x == 1 && y == 1) 
       || (x == 1 && y == 0) 
       || (x == 6 && y == 0)
       || (x == 6 && y == 1) 
       || (x == 7 && y == 1) 
       || (x == 0 && y == 6)
       || (x == 1 && y == 6) 
       || (x == 1 && y == 7) 
       || (x == 6 && y == 6)
       || (x == 7 && y == 6) 
       || (x == 6 && y == 7) )
    return TRUE;
  return FALSE;
}

BOOL IsInSmallSquareorg(int x, int y)
{
    if(x >= 2 && x <= 5 && y >= 2 && y <= 5)
      return TRUE;
    return FALSE;
}

void StateArrayInitialize(STATE *pos)
{
    int k;

    for(k=0; k<64; k++){
      /* rpos,rnrpos̏ */
      PosArrayInitialize((pos[k].rpos));
      PosArrayInitialize((pos[k].rnrpos));
      pos[k].rnrposindex = 0;
    }
}

void PosArrayInitialize(Pos *pos)
{
    int k;
    //int max = sizeof(pos);
    for(k=0; k<64; k++){
      pos[k].x = -1;
      pos[k].y = -1;
      pos[k].get = 0;
    }
}

void NRInitialize(int **map)
{
    int i,j;

#ifdef SHOURYAKU
    return;
#endif
    
    /*  */
    for(i=0;i<MSIZE;i++) {
      for(j=0;j<MSIZE;j++) {
	if(i==0 || j==0 || i==9 || j==9) nrmap[i][j] = 1;
      }
    }
}

void NRCopy(int s[MSIZE][MSIZE], int **c)
{
    int i,j, count=0;

#ifdef SHOURYAKU
    return;
#endif
  
    /* Rs[ */
    for(i=0;i<MSIZE;i++) {
      for(j=0;j<MSIZE;j++) {
	(c[i])[j] = s[i][j];
	count++;
      }
    }
}

BOOL IsNR(int **nrmapbuf, int x, int y)
{
  int c = 0;

#ifdef SHOURYAKU
    return;
#endif

    if((nrmapbuf[x+1])[y+1] == 1) return FALSE;
    
    if((nrmapbuf[x+2])[y+1] == 1 || (nrmapbuf[x])[y+1] == 1)
    if((nrmapbuf[x+1])[y+2] == 1 || (nrmapbuf[x+1])[y] == 1)
    if((nrmapbuf[x+2])[y+2] == 1 || (nrmapbuf[x])[y] == 1)
    if((nrmapbuf[x+2])[y] == 1   || (nrmapbuf[x])[y+2] == 1) {
      (nrmapbuf[x+1])[y+1] = 1;

      if(++c>100000) ddprintf("!!NROKRoop!! %d",x), ddprintf(" %d\n",y), c=0;

      return TRUE;
    }
    return FALSE;
}

void RecheckNRmap(int **nrmapbuf, int State[][SIZE], int Turn, STATE *pos)
{
    int i,j;
    int c=0;

#ifdef SHOURYAKU
    return;
#endif

    for(i=0;i<SIZE;i++){
      for(j=0;j<SIZE;j++){
	if(State[i][j] == Turn) 
	  if(IsNR(nrmapbuf, i, j)) {
	    pos->rnrpos[pos->rnrposindex].x = i;
	    pos->rnrpos[pos->rnrposindex].y = j;
	    pos->rnrposindex++;

	    if(++c > 100000)
	      ddprintf("NRmapReCheckedRooping!\n",-1), c=0;

	    RecheckNRmap(nrmapbuf, State, Turn, pos);
	    return;
	  }/* else ddprintf("else",-1);*/
      }
    }
}

char *DecodeState(int id)
{
    switch(id){
    case OnlyPuttable:
      return "OnlyPuttable";
      break;
    case IsCorner:
      return "IsCorner";
      break;
    case IsInSmallSquare:
      return "IsInSmallSquare";
      break;
    case IsBesideCorner:
      return "IsBesideCorner";
      break;
    case eOnlyPuttable:
      return "eOnlyPuttable";
      break;
    case Corner:
      return "Corner";
      break;
    case OnlyBesideCorner:
      return "OnlyBesideCorner";
      break;
    default:
      return "unknown";
      break;
    }
}

void DumpNRmap(int **map)
{
    int i,j;

#ifndef DEBUG
    return;
#endif
     
    for(i=0; i<MSIZE; i++) {
      for(j=0; j<MSIZE; j++) {
	printf("%d",(map[j])[i]);
      }
      printf("\n");
    }
}

void ddprintf(char *str, int i)
{
#ifdef DEBUG
    if(i != -1) {printf(str,i);}
    else { printf(str); }
    return;
#endif
    return;
} 
