#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "cpu.h"

static Pos GetMax(int [][SIZE], int);
Pos p2142hash(int State[][SIZE], int Turn)
{
	/* vl[` */
	int i,j,k,l,n;
	int num;
	int min,max,hyokamax,mykoma,over[64],count;
	Pos p;
	Pos one[64];
	Pos list[30];
	int hyoka[8][8]={{200,-40, 30, 30, 30, 30,-40,200},
		         {-40,-50,  0,  0,  0,  0,-50,-40},
		         { 45,  0, 45, 40, 40, 45,  0, 45},
		         { 30,  0, 40,-50,-50, 40,  0, 30},
		         { 30,  0, 40,-50,-50, 40,  0, 30},
		         { 45,  0, 45, 40, 40, 45,  0, 45},
		         {-40,-50,  0,  0,  0,  0,-50,-40},
		         {200,-40, 30, 30, 30, 30,-40,200}};
	mykoma = 0;
	if(his_no<12){
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				if(State[i][j] == Turn){
					mykoma++;
				}
			}
		}
		k=0;
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j,NULL);
				if( num > 0 ){
					one[k].x = i; one[k].y = j;
					one[k].get = num;
					over[k] = mykoma + num + 1;
					k++;
				}
			}
		}
		min = 100;
		for(i=0; i<k; i++){
			int **PseudoState1;
			int PState1[SIZE][SIZE];
			int tr = Turn;
			int x, y;
			Pos p1;

			x = one[i].x;
			y = one[i].y;
			PseudoState1 = Put_othello(State, tr, x,y);
			PseudoState1[x][y] = tr;
			CopyState(PseudoState1, PState1);
			freeState(PseudoState1);
			tr *= -1;

			p1 = GetMax(PState1, tr);

			if(p1.get == over[i]){
				hyoka[x][y] = -100;
			}
		}
		min = 100; num = 0; max = 0; hyokamax = -100;
		if(State[1][1] == Turn*(-1) && State[2][2] == Turn*(-1) && State[3][3] == Turn*(-1) && State[4][4] == Turn*(-1) && State[5][5] == Turn*(-1) && State[0][0] == 0){
			for(i=0; i<SIZE; i++){
				for(j=0; j<SIZE; j++){
					Num_of_othello(State, Turn, i,j, list);
					for(k=0; k<=30; k++){
						for(l=2; l<=5; l++){
							if(list[k].x == l && list[k].y == l){
								hyoka[i][j] = hyoka[i][j]+40;
							}
						}
					}
				}
			}
		}
		for(k=0; k<=30; k++){
			list[k].x=0; list[k].y=0; list[k].get=0;
		}
		if(State[1][6] == Turn*(-1) && State[2][5] == Turn*(-1) && State[3][4] == Turn*(-1) && State[4][3] == Turn*(-1) && State[5][2] == Turn*(-1) && State[0][7] == 0){
			for(i=0; i<SIZE; i++){
				for(j=0; j<SIZE; j++){
					Num_of_othello(State, Turn, i,j, list);
					for(k=0; k<=30; k++){
						for(l=2; l<=5; l++){
							if(list[k].x == l && list[k].y == 7-l){
								hyoka[i][j] = hyoka[i][j]+40;
							}
						}
					}
				}
			}
		}
		for(k=0; k<=30; k++){
			list[k].x=0; list[k].y=0; list[k].get=0;
		}
		if(State[6][1] == Turn*(-1) && State[5][2] == Turn*(-1) && State[4][3] == Turn*(-1) && State[3][4] == Turn*(-1) && State[2][5] == Turn*(-1) && State[7][0] == 0){
			for(i=0; i<SIZE; i++){
				for(j=0; j<SIZE; j++){
					Num_of_othello(State, Turn, i,j, list);
					for(k=0; k<=30; k++){
						for(l=2; l<=5; l++){
							if(list[k].x == l && list[k].y == l){
								hyoka[i][j] = hyoka[i][j]+40;
							}
						}
					}
				}
			}
		}
		for(k=0; k<=30; k++){
			list[k].x=0; list[k].y=0; list[k].get=0;
		}
		if(State[6][6] == Turn*(-1) && State[5][5] == Turn*(-1) && State[4][4] == Turn*(-1) && State[3][3] == Turn*(-1) && State[2][2] == Turn*(-1) && State[7][7] == 0){
			for(i=0; i<SIZE; i++){
				for(j=0; j<SIZE; j++){
					Num_of_othello(State, Turn, i,j, list);
					for(k=0; k<=30; k++){
						for(l=2; l<=5; l++){
							if(list[k].x == l && list[k].y == 7-l){
								hyoka[i][j] = hyoka[i][j]+40;
							}
						}
					}
				}
			}
		}
		for(k=0; k<=30; k++){
			list[k].x=0; list[k].y=0; list[k].get=0;
		}
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j, NULL);
				if( hyoka[i][j] == hyokamax && num >= 1){
					list[count].x = i; list[count].y = j;
					list[count].get = num;
					count++;
				}
				if( hyoka[i][j] > hyokamax && num >= 1){
					count=0;
					list[count].x = i; list[count].y = j;
					list[count].get = num;
					hyokamax = hyoka[i][j];
					count++;
				}
				if( num >= max ){
					max = num;
				}
			}
		}
		if(count!=0){
			srand((unsigned)time(NULL));
			n=rand()%count;
			p.x=list[n].x; p.y=list[n].y; p.get=list[n].get;
		}
		if(max == 0){
			p.x = -1;
			p.y = -1;
			p.get = 0;
		}
		for(k=0; k<=30; k++){
			list[k].x=0; list[k].y=0; list[k].get=0;
		}
	}
	if(his_no>=12 && his_no<=35){
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j, NULL);
				if( hyoka[i][j] >= hyokamax && num >= 1){
					hyokamax = hyoka[i][j];
				}
			}
		}
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j, NULL);
				if(num >= 6){
					hyoka[i][j] = hyoka[i][j]-5;
				}
			}
		}
		num = 0; hyokamax = -100;
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j, NULL);
				if( hyoka[i][j] >= hyokamax && num >= 1){
					hyokamax = hyoka[i][j];
				}
			}
		}
		count = 0;
		for(i=1; i<6; i++){
			if(count == 0 && State[0][0] == 0){
				count=1;
			}
			if(count == 1 && State[i][i] == Turn*(-1)){
				break;
			}
			if(count == 1 && State[i][i] == Turn){
				count=2;
			}
			if(State[2][2] == 0 || State[5][5] == 0){
				break;
			}
			if(count == 2 && State[i][i] == Turn*(-1)){
				count=3;
			}
			if(count == 3 && State[i][i] == Turn){
				count=0;
			}
			if(count >=2 && i==5 && hyokamax <= -30){
				hyoka[6][6]=hyoka[6][6]+100;
				break;
			}
		}
		num = 0; hyokamax = -100;
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j, NULL);
				if( hyoka[i][j] >= hyokamax && num >= 1){
					hyokamax = hyoka[i][j];
				}
			}
		}
		count = 0;
		for(i=6; i>1; i--){
			if(count == 0 && State[7][7] == 0){
				count=1;
			}
			if(count == 1 && State[i][i] == Turn*(-1)){
				break;
			}
			if(count == 1 && State[i][i] == Turn){
				count=2;
			}
			if(State [2][2] == 0 || State[5][5] == 0){
				break;
			}
			if(count == 2 && State[i][i] == Turn*(-1)){
				count=3;
			}
			if(count == 3 && State[i][i] == Turn){
				count=0;
			}
			if(count >=2 && i==2 && hyokamax <= -30){
				hyoka[1][1]=hyoka[1][1]+100;
				break;
			}
		}
		num = 0; hyokamax = -100;
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j, NULL);
				if( hyoka[i][j] >= hyokamax && num >= 1){
					hyokamax = hyoka[i][j];
				}
			}
		}
		count = 0;
		for(i=1; i<6; i++){
			if(count == 0 && State[0][7] == 0){
				count=1;
			}
			if(count == 1 && State[i][7-i] == Turn*(-1)){
				break;
			}
			if(count == 1 && State[i][7-i] == Turn){
				count=2;
			}
			if(State[2][5] == 0 || State[5][2] == 0){
				break;
			}
			if(count == 2 && State[i][7-i] == Turn*(-1)){
				count=3;
			}
			if(count == 3 && State[i][7-i] == Turn){
				count=0;
			}
			if(count >=2 && i==5 && hyokamax <= -30){
				hyoka[6][1]=hyoka[6][1]+100;
				break;
			}
		}
		num = 0; hyokamax = -100;
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j, NULL);
				if( hyoka[i][j] >= hyokamax && num >= 1){
					hyokamax = hyoka[i][j];
				}
			}
		}
		count = 0;
		for(i=1; i<6; i++){
			if(count == 0 && State[7][0] == 0){
				count=1;
			}
			if(count == 1 && State[7-i][i] == Turn*(-1)){
				break;
			}
			if(count == 1 && State[7-i][i] == Turn){
				count=2;
			}
			if(State[2][5] == 0 || State[5][2] == 0){
				break;
			}
			if(count == 2 && State[7-i][i] == Turn*(-1)){
				count=3;
			}
			if(count == 3 && State[7-i][i] == Turn){
				count=0;
			}
			if(count <=2 && i==5 && hyokamax <= -30){
				hyoka[1][6]=hyoka[1][6]+100;
				break;
			}
		}
		count = 0;
		for(i=1; i<=6; i++){
			if(count == 0 && State[0][0] == Turn){
				count=1;
			}
			if(count == 1 && State[0][i] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[0][i] == 0){
				count=3;
			}
			if(count == 2 && State[0][i] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[0][i]=hyoka[0][i]+100;
				break;
			}
		}
		count = 0;
		for(i=1; i<=6; i++){
			if(count == 0 && State[0][0] == Turn){
				count=1;
			}
			if(count == 1 && State[i][0] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[i][0] == 0){
				count=3;
			}
			if(count == 2 && State[i][0] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[i][0]=hyoka[i][0]+100;
				break;
			}
		}
		count = 0;
		for(i=6; i>=1; i--){
			if(count == 0 && State[7][0] == Turn){
				count=1;
			}
			if(count == 1 && State[i][0] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[i][0] == 0){
				count=3;
			}
			if(count == 2 && State[i][0] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[i][0]=hyoka[i][0]+100;
				break;
			}
		}
		count = 0;
		for(i=6; i>=1; i--){
			if(count == 0 && State[0][7] == Turn){
				count=1;
			}
			if(count == 1 && State[0][i] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[0][i] == 0){
				count=3;
			}
			if(count == 2 && State[0][i] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[0][i]=hyoka[0][i]+100;
				break;
			}
		}
		count = 0;
		for(i=1; i<=6; i++){
			if(count == 0 && State[7][0] == Turn){
				count=1;
			}
			if(count == 1 && State[7][i] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[7][i] == 0){
				count=3;
			}
			if(count == 2 && State[7][i] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[7][i]=hyoka[7][i]+100;
				break;
			}
		}
		count = 0;
		for(i=1; i<=6; i++){
			if(count == 0 && State[0][7] == Turn){
				count=1;
			}
			if(count == 1 && State[i][7] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[i][7] == 0){
				count=3;
			}
			if(count == 2 && State[i][7] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[i][0]=hyoka[i][0]+100;
				break;
			}
		}
		count = 0;
		for(i=6; i>=1; i--){
			if(count == 0 && State[7][7] == Turn){
				count=1;
			}
			if(count == 1 && State[i][7] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[i][7] == 0){
				count=3;
			}
			if(count == 2 && State[i][7] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[i][7]=hyoka[i][7]+100;
				break;
			}
		}
		count = 0;
		for(i=6; i>=1; i--){
			if(count == 0 && State[7][7] == Turn){
				count=1;
			}
			if(count == 1 && State[7][i] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[7][i] == 0){
				count=3;
			}
			if(count == 2 && State[7][i] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[7][i]=hyoka[7][i]+100;
				break;
			}
		}
		count = 0;
		for(i=0; i<SIZE; i++){
			if(State[0][i]!=0){
				count++;
			}
			else{count=0;}
			if(count>=3){
				hyoka[1][i-1] = hyoka[1][i-1]+50;
			}
		}
		count = 0;
		for(i=0; i<SIZE; i++){
			if(State[i][0]!=0){
				count++;
			}
			else{count=0;}
			if(count>=3){
				hyoka[i-1][1] = hyoka[i-1][1]+50;
			}
		}
		count = 0;
		for(i=0; i<SIZE; i++){
			if(State[7][i]!=0){
				count++;
			}
			else{count=0;}
			if(count>=3){
				hyoka[6][i-1] = hyoka[6][i-1]+50;
			}
		}
		count = 0;
		for(i=0; i<SIZE; i++){
			if(State[i][7]!=0){
				count++;
			}
			else{count=0;}
			if(count>=3){
				hyoka[i-1][6] = hyoka[i-1][6]+50;
			}
		}
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				if(State[i][j] == Turn){
					mykoma++;
				}
			}
		}
		k=0;
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j,NULL);
				if( num > 0 ){
					one[k].x = i; one[k].y = j;
					one[k].get = num;
					over[k] = mykoma + num + 1;
					k++;
				}
			}
		}
		for(i=0; i<k; i++){
			int **PseudoState1;
			int PState1[SIZE][SIZE];
			int tr = Turn;
			int x, y;
			Pos p1;

			x = one[i].x;
			y = one[i].y;
			PseudoState1 = Put_othello(State, tr, x,y);
			PseudoState1[x][y] = tr;
			CopyState(PseudoState1, PState1);
			freeState(PseudoState1);
			tr *= -1;

			p1 = GetMax(PState1, tr);

			if(p1.get == over[i]){
				hyoka[x][y] = -100;
			}
		}
		min = 100; num = 0; max = 0; hyokamax = -100;
		if(State[1][1] == Turn*(-1) && State[2][2] == Turn*(-1) && State[3][3] == Turn*(-1) && State[4][4] == Turn*(-1) && State[5][5] == Turn*(-1) && State[0][0] == 0){
			for(i=0; i<SIZE; i++){
				for(j=0; j<SIZE; j++){
					Num_of_othello(State, Turn, i,j, list);
					for(k=0; k<=30; k++){
						for(l=2; l<=5; l++){
							if(list[k].x == l && list[k].y == l){
								hyoka[i][j] = hyoka[i][j]+40;
							}
						}
					}
				}
			}
		}
		for(k=0; k<=30; k++){
			list[k].x=0; list[k].y=0; list[k].get=0;
		}
		if(State[1][6] == Turn*(-1) && State[2][5] == Turn*(-1) && State[3][4] == Turn*(-1) && State[4][3] == Turn*(-1) && State[5][2] == Turn*(-1) && State[0][7] == 0){
			for(i=0; i<SIZE; i++){
				for(j=0; j<SIZE; j++){
					Num_of_othello(State, Turn, i,j, list);
					for(k=0; k<=30; k++){
						for(l=2; l<=5; l++){
							if(list[k].x == l && list[k].y == 7-l){
								hyoka[i][j] = hyoka[i][j]+40;
							}
						}
					}
				}
			}
		}
		for(k=0; k<=30; k++){
			list[k].x=0; list[k].y=0; list[k].get=0;
		}
		if(State[6][1] == Turn*(-1) && State[5][2] == Turn*(-1) && State[4][3] == Turn*(-1) && State[3][4] == Turn*(-1) && State[2][5] == Turn*(-1) && State[7][0] == 0){
			for(i=0; i<SIZE; i++){
				for(j=0; j<SIZE; j++){
					Num_of_othello(State, Turn, i,j, list);
					for(k=0; k<=30; k++){
						for(l=2; l<=5; l++){
							if(list[k].x == l && list[k].y == l){
								hyoka[i][j] = hyoka[i][j]+40;
							}
						}
					}
				}
			}
		}
		for(k=0; k<=30; k++){
			list[k].x=0; list[k].y=0; list[k].get=0;
		}
		if(State[6][6] == Turn*(-1) && State[5][5] == Turn*(-1) && State[4][4] == Turn*(-1) && State[3][3] == Turn*(-1) && State[2][2] == Turn*(-1) && State[7][7] == 0){
			for(i=0; i<SIZE; i++){
				for(j=0; j<SIZE; j++){
					Num_of_othello(State, Turn, i,j, list);
					for(k=0; k<=30; k++){
						for(l=2; l<=5; l++){
							if(list[k].x == l && list[k].y == 7-l){
								hyoka[i][j] = hyoka[i][j]+40;
							}
						}
					}
				}
			}
		}
		for(k=0; k<=30; k++){
			list[k].x=0; list[k].y=0; list[k].get=0;
		}
		for(i=2; i<=6; i++){
			if(State[0][1] !=0 || State[0][i] != Turn*(-1) || State[0][7] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[1][1] = hyoka[1][1]+200;
		}
		for(i=2; i<=6; i++){
			if(State[0][0] !=Turn*(-1)|| State[0][1] !=0 || State[0][i] != Turn*(-1) || State[0][7] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[0][1] = hyoka[0][1]+100;
		}
		for(i=1; i<=5; i++){
			if(State[0][6] !=0 || State[0][i] != Turn*(-1) || State[0][0] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[1][6] = hyoka[1][6]+200;
		}
		for(i=1; i<=5; i++){
			if(State[0][7] !=Turn*(-1) || State[0][6] !=0 || State[0][i] != Turn*(-1) || State[0][0] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[0][6] = hyoka[0][6]+100;
		}
		for(i=2; i<=6; i++){
			if(State[7][1] !=0 || State[7][i] != Turn*(-1) || State[7][7] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[6][1] = hyoka[6][1]+200;
		}
		for(i=2; i<=6; i++){
			if(State[7][0] != Turn*(-1) || State[7][1] !=0 || State[7][i] != Turn*(-1) || State[7][7] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[7][1] = hyoka[7][1]+100;
		}
		for(i=1; i<=5; i++){
			if(State[7][6] !=0 || State[7][i] != Turn*(-1) || State[7][0] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[6][6] = hyoka[6][6]+200;
		}
		for(i=1; i<=5; i++){
			if(State[7][7] != Turn*(-1) || State[7][6] !=0 || State[7][i] != Turn*(-1) || State[7][0] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[7][6] = hyoka[7][6]+100;
		}
		for(i=2; i<=6; i++){
			if(State[1][0] !=0 || State[i][0] != Turn*(-1) || State[7][0] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[1][1] = hyoka[1][1]+200;
		}
		for(i=2; i<=6; i++){
			if(State[0][0] != Turn*(-1) || State[1][0] !=0 || State[i][0] != Turn*(-1) || State[7][0] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[1][0] = hyoka[1][0]+100;
		}
		for(i=1; i<=5; i++){
			if(State[6][0] !=0 || State[i][0] != Turn*(-1) || State[0][0] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[6][1] = hyoka[6][1]+200;
		}
		for(i=1; i<=5; i++){
			if(State[7][0] != Turn*(-1) || State[6][0] !=0 || State[i][0] != Turn*(-1) || State[0][0] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[6][0] = hyoka[6][0]+100;
		}
		for(i=2; i<=6; i++){
			if(State[1][7] !=0 || State[i][7] != Turn*(-1) || State[7][7] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[1][6] = hyoka[1][6]+200;
		}
		for(i=2; i<=6; i++){
			if(State[0][7] != Turn*(-1) || State[1][7] !=0 || State[i][7] != Turn*(-1) || State[7][7] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[1][7] = hyoka[1][7]+100;
		}
		for(i=1; i<=5; i++){
			if(State[6][7] !=0 || State[i][7] != Turn*(-1) || State[0][7] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[6][6] = hyoka[6][6]+200;
		}
		for(i=1; i<=5; i++){
			if(State[7][7] != Turn*(-1) || State[6][7] !=0 || State[i][7] != Turn*(-1) || State[0][7] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[6][7] = hyoka[6][7]+100;
		}
		if(State[0][0] != 0){
			hyoka[1][0] = hyoka[1][0]+80;
			hyoka[0][1] = hyoka[0][1]+80;
			hyoka[1][1] = hyoka[1][1]+80;
		}
		if(State[0][7] != 0){
			hyoka[0][6] = hyoka[0][6]+80;
			hyoka[1][7] = hyoka[1][7]+80;
			hyoka[1][6] = hyoka[1][6]+80;
		}
		if(State[7][0] != 0){
			hyoka[6][0] = hyoka[6][0]+80;
			hyoka[7][1] = hyoka[7][1]+80;
			hyoka[6][1] = hyoka[6][1]+80;
		}
		if(State[7][7] != 0){
			hyoka[6][7] = hyoka[6][7]+80;
			hyoka[7][6] = hyoka[7][6]+80;
			hyoka[6][6] = hyoka[6][6]+80;
		}
		min = 100; num = 0; max = 0; hyokamax = -100;
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j, NULL);
				if( hyoka[i][j] == hyokamax && num >= 1){
					list[count].x = i; list[count].y = j;
					list[count].get = num;
					count++;
				}
				if( hyoka[i][j] > hyokamax && num >= 1){
					count=0;
					list[count].x = i; list[count].y = j;
					list[count].get = num;
					hyokamax = hyoka[i][j];
					count++;
				}
				if( num >= max ){
					max = num;
				}
			}
		}
		if(count!=0){
			srand((unsigned)time(NULL));
			n=rand()%count;
			p.x=list[n].x; p.y=list[n].y; p.get=list[n].get;
		}
		if(max == 0){
			p.x = -1;
			p.y = -1;
			p.get = 0;
		}
		for(k=0; k<=30; k++){
			list[k].x=0; list[k].y=0; list[k].get=0;
		}
	}
	if(his_no>=36 && his_no<=50){
		num = 0; hyokamax = -100;
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j, NULL);
				if( hyoka[i][j] >= hyokamax && num >= 1){
					hyokamax = hyoka[i][j];
				}
			}
		}
		count = 0;
		for(i=1; i<6; i++){
			if(count == 0 && State[0][0] == 0){
				count=1;
			}
			if(count == 1 && State[i][i] == Turn*(-1)){
				break;
			}
			if(count == 1 && State[i][i] == Turn){
				count=2;
			}
			if(State[2][2] == 0 || State[5][5] == 0){
				break;
			}
			if(count == 2 && State[i][i] == Turn*(-1)){
				count=3;
			}
			if(count == 3 && State[i][i] == Turn){
				count=0;
			}
			if(count >=2 && i==5 && hyokamax <= -30){
				hyoka[6][6]=hyoka[6][6]+100;
				break;
			}
		}
		num = 0; hyokamax = -100;
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j, NULL);
				if( hyoka[i][j] >= hyokamax && num >= 1){
					hyokamax = hyoka[i][j];
				}
			}
		}
		count = 0;
		for(i=6; i>1; i--){
			if(count == 0 && State[7][7] == 0){
				count=1;
			}
			if(count == 1 && State[i][i] == Turn*(-1)){
				break;
			}
			if(count == 1 && State[i][i] == Turn){
				count=2;
			}
			if(State [2][2] == 0 || State[5][5] == 0){
				break;
			}
			if(count == 2 && State[i][i] == Turn*(-1)){
				count=3;
			}
			if(count == 3 && State[i][i] == Turn){
				count=0;
			}
			if(count >=2 && i==2 && hyokamax <= -30){
				hyoka[1][1]=hyoka[1][1]+100;
				break;
			}
		}
		num = 0; hyokamax = -100;
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j, NULL);
				if( hyoka[i][j] >= hyokamax && num >= 1){
					hyokamax = hyoka[i][j];
				}
			}
		}
		count = 0;
		for(i=1; i<6; i++){
			if(count == 0 && State[0][7] == 0){
				count=1;
			}
			if(count == 1 && State[i][7-i] == Turn*(-1)){
				break;
			}
			if(count == 1 && State[i][7-i] == Turn){
				count=2;
			}
			if(State[2][5] == 0 || State[5][2] == 0){
				break;
			}
			if(count == 2 && State[i][7-i] == Turn*(-1)){
				count=3;
			}
			if(count == 3 && State[i][7-i] == Turn){
				count=0;
			}
			if(count >=2 && i==5 && hyokamax <= -30){
				hyoka[6][1]=hyoka[6][1]+100;
				break;
			}
		}
		num = 0; hyokamax = -100;
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j, NULL);
				if( hyoka[i][j] >= hyokamax && num >= 1){
					hyokamax = hyoka[i][j];
				}
			}
		}
		count = 0;
		for(i=1; i<6; i++){
			if(count == 0 && State[7][0] == 0){
				count=1;
			}
			if(count == 1 && State[7-i][i] == Turn*(-1)){
				break;
			}
			if(count == 1 && State[7-i][i] == Turn){
				count=2;
			}
			if(State[2][5] == 0 || State[5][2] == 0){
				break;
			}
			if(count == 2 && State[7-i][i] == Turn*(-1)){
				count=3;
			}
			if(count == 3 && State[7-i][i] == Turn){
				count=0;
			}
			if(count <=2 && i==5 && hyokamax <= -30){
				hyoka[1][6]=hyoka[1][6]+100;
				break;
			}
		}
		count = 0;
		for(i=1; i<=6; i++){
			if(count == 0 && State[0][0] == Turn){
				count=1;
			}
			if(count == 1 && State[0][i] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[0][i] == 0){
				count=3;
			}
			if(count == 2 && State[0][i] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[0][i]=hyoka[0][i]+100;
				break;
			}
		}
		count = 0;
		for(i=1; i<=6; i++){
			if(count == 0 && State[0][0] == Turn){
				count=1;
			}
			if(count == 1 && State[i][0] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[i][0] == 0){
				count=3;
			}
			if(count == 2 && State[i][0] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[i][0]=hyoka[i][0]+100;
				break;
			}
		}
		count = 0;
		for(i=6; i>=1; i--){
			if(count == 0 && State[7][0] == Turn){
				count=1;
			}
			if(count == 1 && State[i][0] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[i][0] == 0){
				count=3;
			}
			if(count == 2 && State[i][0] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[i][0]=hyoka[i][0]+100;
				break;
			}
		}
		count = 0;
		for(i=6; i>=1; i--){
			if(count == 0 && State[0][7] == Turn){
				count=1;
			}
			if(count == 1 && State[0][i] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[0][i] == 0){
				count=3;
			}
			if(count == 2 && State[0][i] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[0][i]=hyoka[0][i]+100;
				break;
			}
		}
		count = 0;
		for(i=1; i<=6; i++){
			if(count == 0 && State[7][0] == Turn){
				count=1;
			}
			if(count == 1 && State[7][i] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[7][i] == 0){
				count=3;
			}
			if(count == 2 && State[7][i] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[7][i]=hyoka[7][i]+100;
				break;
			}
		}
		count = 0;
		for(i=1; i<=6; i++){
			if(count == 0 && State[0][7] == Turn){
				count=1;
			}
			if(count == 1 && State[i][7] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[i][7] == 0){
				count=3;
			}
			if(count == 2 && State[i][7] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[i][0]=hyoka[i][0]+100;
				break;
			}
		}
		count = 0;
		for(i=6; i>=1; i--){
			if(count == 0 && State[7][7] == Turn){
				count=1;
			}
			if(count == 1 && State[i][7] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[i][7] == 0){
				count=3;
			}
			if(count == 2 && State[i][7] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[i][7]=hyoka[i][7]+100;
				break;
			}
		}
		count = 0;
		for(i=6; i>=1; i--){
			if(count == 0 && State[7][7] == Turn){
				count=1;
			}
			if(count == 1 && State[7][i] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[7][i] == 0){
				count=3;
			}
			if(count == 2 && State[7][i] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[7][i]=hyoka[7][i]+100;
				break;
			}
		}
		count = 0;
		for(i=0; i<SIZE; i++){
			if(State[0][i]!=0){
				count++;
			}
			else{count=0;}
			if(count>=3){
				hyoka[1][i-1] = hyoka[1][i-1]+50;
			}
		}
		count = 0;
		for(i=0; i<SIZE; i++){
			if(State[i][0]!=0){
				count++;
			}
			else{count=0;}
			if(count>=3){
				hyoka[i-1][1] = hyoka[i-1][1]+50;
			}
		}
		count = 0;
		for(i=0; i<SIZE; i++){
			if(State[7][i]!=0){
				count++;
			}
			else{count=0;}
			if(count>=3){
				hyoka[6][i-1] = hyoka[6][i-1]+50;
			}
		}
		count = 0;
		for(i=0; i<SIZE; i++){
			if(State[i][7]!=0){
				count++;
			}
			else{count=0;}
			if(count>=3){
				hyoka[i-1][6] = hyoka[i-1][6]+50;
			}
		}
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				if(State[i][j] == Turn){
					mykoma++;
				}
			}
		}
		k=0;
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j,NULL);
				if( num > 0 ){
					one[k].x = i; one[k].y = j;
					one[k].get = num;
					over[k] = mykoma + num + 1;
					k++;
				}
			}
		}
		for(i=0; i<k; i++){
			int **PseudoState1;
			int PState1[SIZE][SIZE];
			int tr = Turn;
			int x, y;
			Pos p1;

			x = one[i].x;
			y = one[i].y;
			PseudoState1 = Put_othello(State, tr, x,y);
			PseudoState1[x][y] = tr;
			CopyState(PseudoState1, PState1);
			freeState(PseudoState1);
			tr *= -1;

			p1 = GetMax(PState1, tr);

			if(p1.get == over[i]){
				hyoka[x][y] = -100;
			}
		}
		min = 100; num = 0; max = 0; hyokamax = -100;
		if(State[1][1] == Turn*(-1) && State[2][2] == Turn*(-1) && State[3][3] == Turn*(-1) && State[4][4] == Turn*(-1) && State[5][5] == Turn*(-1) && State[0][0] == 0){
			for(i=0; i<SIZE; i++){
				for(j=0; j<SIZE; j++){
					Num_of_othello(State, Turn, i,j, list);
					for(k=0; k<=30; k++){
						for(l=2; l<=5; l++){
							if(list[k].x == l && list[k].y == l){
								hyoka[i][j] = hyoka[i][j]+40;
							}
						}
					}
				}
			}
		}
		for(k=0; k<=30; k++){
			list[k].x=0; list[k].y=0; list[k].get=0;
		}
		if(State[1][6] == Turn*(-1) && State[2][5] == Turn*(-1) && State[3][4] == Turn*(-1) && State[4][3] == Turn*(-1) && State[5][2] == Turn*(-1) && State[0][7] == 0){
			for(i=0; i<SIZE; i++){
				for(j=0; j<SIZE; j++){
					Num_of_othello(State, Turn, i,j, list);
					for(k=0; k<=30; k++){
						for(l=2; l<=5; l++){
							if(list[k].x == l && list[k].y == 7-l){
								hyoka[i][j] = hyoka[i][j]+40;
							}
						}
					}
				}
			}
		}
		for(k=0; k<=30; k++){
			list[k].x=0; list[k].y=0; list[k].get=0;
		}
		if(State[6][1] == Turn*(-1) && State[5][2] == Turn*(-1) && State[4][3] == Turn*(-1) && State[3][4] == Turn*(-1) && State[2][5] == Turn*(-1) && State[7][0] == 0){
			for(i=0; i<SIZE; i++){
				for(j=0; j<SIZE; j++){
					Num_of_othello(State, Turn, i,j, list);
					for(k=0; k<=30; k++){
						for(l=2; l<=5; l++){
							if(list[k].x == l && list[k].y == l){
								hyoka[i][j] = hyoka[i][j]+40;
							}
						}
					}
				}
			}
		}
		for(k=0; k<=30; k++){
			list[k].x=0; list[k].y=0; list[k].get=0;
		}
		if(State[6][6] == Turn*(-1) && State[5][5] == Turn*(-1) && State[4][4] == Turn*(-1) && State[3][3] == Turn*(-1) && State[2][2] == Turn*(-1) && State[7][7] == 0){
			for(i=0; i<SIZE; i++){
				for(j=0; j<SIZE; j++){
					Num_of_othello(State, Turn, i,j, list);
					for(k=0; k<=30; k++){
						for(l=2; l<=5; l++){
							if(list[k].x == l && list[k].y == 7-l){
								hyoka[i][j] = hyoka[i][j]+40;
							}
						}
					}
				}
			}
		}
		for(k=0; k<=30; k++){
			list[k].x=0; list[k].y=0; list[k].get=0;
		}
		for(i=2; i<=6; i++){
			if(State[0][1] !=0 || State[0][i] != Turn*(-1) || State[0][7] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[1][1] = hyoka[1][1]+200;
		}
		for(i=2; i<=6; i++){
			if(State[0][0] !=Turn*(-1)|| State[0][1] !=0 || State[0][i] != Turn*(-1) || State[0][7] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[0][1] = hyoka[0][1]+100;
		}
		for(i=1; i<=5; i++){
			if(State[0][6] !=0 || State[0][i] != Turn*(-1) || State[0][0] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[1][6] = hyoka[1][6]+200;
		}
		for(i=1; i<=5; i++){
			if(State[0][7] !=Turn*(-1) || State[0][6] !=0 || State[0][i] != Turn*(-1) || State[0][0] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[0][6] = hyoka[0][6]+100;
		}
		for(i=2; i<=6; i++){
			if(State[7][1] !=0 || State[7][i] != Turn*(-1) || State[7][7] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[6][1] = hyoka[6][1]+200;
		}
		for(i=2; i<=6; i++){
			if(State[7][0] != Turn*(-1) || State[7][1] !=0 || State[7][i] != Turn*(-1) || State[7][7] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[7][1] = hyoka[7][1]+100;
		}
		for(i=1; i<=5; i++){
			if(State[7][6] !=0 || State[7][i] != Turn*(-1) || State[7][0] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[6][6] = hyoka[6][6]+200;
		}
		for(i=1; i<=5; i++){
			if(State[7][7] != Turn*(-1) || State[7][6] !=0 || State[7][i] != Turn*(-1) || State[7][0] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[7][6] = hyoka[7][6]+100;
		}
		for(i=2; i<=6; i++){
			if(State[1][0] !=0 || State[i][0] != Turn*(-1) || State[7][0] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[1][1] = hyoka[1][1]+200;
		}
		for(i=2; i<=6; i++){
			if(State[0][0] != Turn*(-1) || State[1][0] !=0 || State[i][0] != Turn*(-1) || State[7][0] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[1][0] = hyoka[1][0]+100;
		}
		for(i=1; i<=5; i++){
			if(State[6][0] !=0 || State[i][0] != Turn*(-1) || State[0][0] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[6][1] = hyoka[6][1]+200;
		}
		for(i=1; i<=5; i++){
			if(State[7][0] != Turn*(-1) || State[6][0] !=0 || State[i][0] != Turn*(-1) || State[0][0] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[6][0] = hyoka[6][0]+100;
		}
		for(i=2; i<=6; i++){
			if(State[1][7] !=0 || State[i][7] != Turn*(-1) || State[7][7] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[1][6] = hyoka[1][6]+200;
		}
		for(i=2; i<=6; i++){
			if(State[0][7] != Turn*(-1) || State[1][7] !=0 || State[i][7] != Turn*(-1) || State[7][7] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[1][7] = hyoka[1][7]+100;
		}
		for(i=1; i<=5; i++){
			if(State[6][7] !=0 || State[i][7] != Turn*(-1) || State[0][7] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[6][6] = hyoka[6][6]+200;
		}
		for(i=1; i<=5; i++){
			if(State[7][7] != Turn*(-1) || State[6][7] !=0 || State[i][7] != Turn*(-1) || State[0][7] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[6][7] = hyoka[6][7]+100;
		}
		if(State[0][0] != 0){
			hyoka[1][0] = hyoka[1][0]+80;
			hyoka[0][1] = hyoka[0][1]+80;
			hyoka[1][1] = hyoka[1][1]+80;
		}
		if(State[0][7] != 0){
			hyoka[0][6] = hyoka[0][6]+80;
			hyoka[1][7] = hyoka[1][7]+80;
			hyoka[1][6] = hyoka[1][6]+80;
		}
		if(State[7][0] != 0){
			hyoka[6][0] = hyoka[6][0]+80;
			hyoka[7][1] = hyoka[7][1]+80;
			hyoka[6][1] = hyoka[6][1]+80;
		}
		if(State[7][7] != 0){
			hyoka[6][7] = hyoka[6][7]+80;
			hyoka[7][6] = hyoka[7][6]+80;
			hyoka[6][6] = hyoka[6][6]+80;
		}
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j, NULL);
				if( hyoka[i][j] == hyokamax && num >= 1){
					list[count].x = i; list[count].y = j;
					list[count].get = num;
					count++;
				}
				if( hyoka[i][j] > hyokamax && num >= 1){
					count=0;
					list[count].x = i; list[count].y = j;
					list[count].get = num;
					hyokamax = hyoka[i][j];
					count++;
				}
				if( num >= max ){
					max = num;
				}
			}
		}
		if(count!=0){
			srand((unsigned)time(NULL));
			n=rand()%count;
			p.x=list[n].x; p.y=list[n].y; p.get=list[n].get;
		}
		if(max == 0){
			p.x = -1;
			p.y = -1;
			p.get = 0;
		}
		for(k=0; k<=30; k++){
			list[k].x=0; list[k].y=0; list[k].get=0;
		}
	}
	if(his_no>=51 && his_no<=58){
		num = 0; hyokamax = -100;
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j, NULL);
				if( hyoka[i][j] >= hyokamax && num >= 1){
					hyokamax = hyoka[i][j];
				}
			}
		}
		count = 0;
		for(i=1; i<6; i++){
			if(count == 0 && State[0][0] == 0){
				count=1;
			}
			if(count == 1 && State[i][i] == Turn*(-1)){
				break;
			}
			if(count == 1 && State[i][i] == Turn){
				count=2;
			}
			if(State[2][2] == 0 || State[5][5] == 0){
				break;
			}
			if(count == 2 && State[i][i] == Turn*(-1)){
				count=3;
			}
			if(count == 3 && State[i][i] == Turn){
				count=0;
			}
			if(count >=2 && i==5 && hyokamax <= -30){
				hyoka[6][6]=hyoka[6][6]+100;
				break;
			}
		}
		num = 0; hyokamax = -100;
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j, NULL);
				if( hyoka[i][j] >= hyokamax && num >= 1){
					hyokamax = hyoka[i][j];
				}
			}
		}
		count = 0;
		for(i=6; i>1; i--){
			if(count == 0 && State[7][7] == 0){
				count=1;
			}
			if(count == 1 && State[i][i] == Turn*(-1)){
				break;
			}
			if(count == 1 && State[i][i] == Turn){
				count=2;
			}
			if(State [2][2] == 0 || State[5][5] == 0){
				break;
			}
			if(count == 2 && State[i][i] == Turn*(-1)){
				count=3;
			}
			if(count == 3 && State[i][i] == Turn){
				count=0;
			}
			if(count >=2 && i==2 && hyokamax <= -30){
				hyoka[1][1]=hyoka[1][1]+100;
				break;
			}
		}
		num = 0; hyokamax = -100;
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j, NULL);
				if( hyoka[i][j] >= hyokamax && num >= 1){
					hyokamax = hyoka[i][j];
				}
			}
		}
		count = 0;
		for(i=1; i<6; i++){
			if(count == 0 && State[0][7] == 0){
				count=1;
			}
			if(count == 1 && State[i][7-i] == Turn*(-1)){
				break;
			}
			if(count == 1 && State[i][7-i] == Turn){
				count=2;
			}
			if(State[2][5] == 0 || State[5][2] == 0){
				break;
			}
			if(count == 2 && State[i][7-i] == Turn*(-1)){
				count=3;
			}
			if(count == 3 && State[i][7-i] == Turn){
				count=0;
			}
			if(count >=2 && i==5 && hyokamax <= -30){
				hyoka[6][1]=hyoka[6][1]+100;
				break;
			}
		}
		num = 0; hyokamax = -100;
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j, NULL);
				if( hyoka[i][j] >= hyokamax && num >= 1){
					hyokamax = hyoka[i][j];
				}
			}
		}
		count = 0;
		for(i=1; i<6; i++){
			if(count == 0 && State[7][0] == 0){
				count=1;
			}
			if(count == 1 && State[7-i][i] == Turn*(-1)){
				break;
			}
			if(count == 1 && State[7-i][i] == Turn){
				count=2;
			}
			if(State[2][5] == 0 || State[5][2] == 0){
				break;
			}
			if(count == 2 && State[7-i][i] == Turn*(-1)){
				count=3;
			}
			if(count == 3 && State[7-i][i] == Turn){
				count=0;
			}
			if(count <=2 && i==5 && hyokamax <= -30){
				hyoka[1][6]=hyoka[1][6]+100;
				break;
			}
		}
		count = 0;
		for(i=1; i<=6; i++){
			if(count == 0 && State[0][0] == Turn){
				count=1;
			}
			if(count == 1 && State[0][i] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[0][i] == 0){
				count=3;
			}
			if(count == 2 && State[0][i] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[0][i]=hyoka[0][i]+100;
				break;
			}
		}
		count = 0;
		for(i=1; i<=6; i++){
			if(count == 0 && State[0][0] == Turn){
				count=1;
			}
			if(count == 1 && State[i][0] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[i][0] == 0){
				count=3;
			}
			if(count == 2 && State[i][0] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[i][0]=hyoka[i][0]+100;
				break;
			}
		}
		count = 0;
		for(i=6; i>=1; i--){
			if(count == 0 && State[7][0] == Turn){
				count=1;
			}
			if(count == 1 && State[i][0] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[i][0] == 0){
				count=3;
			}
			if(count == 2 && State[i][0] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[i][0]=hyoka[i][0]+100;
				break;
			}
		}
		count = 0;
		for(i=6; i>=1; i--){
			if(count == 0 && State[0][7] == Turn){
				count=1;
			}
			if(count == 1 && State[0][i] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[0][i] == 0){
				count=3;
			}
			if(count == 2 && State[0][i] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[0][i]=hyoka[0][i]+100;
				break;
			}
		}
		count = 0;
		for(i=1; i<=6; i++){
			if(count == 0 && State[7][0] == Turn){
				count=1;
			}
			if(count == 1 && State[7][i] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[7][i] == 0){
				count=3;
			}
			if(count == 2 && State[7][i] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[7][i]=hyoka[7][i]+100;
				break;
			}
		}
		count = 0;
		for(i=1; i<=6; i++){
			if(count == 0 && State[0][7] == Turn){
				count=1;
			}
			if(count == 1 && State[i][7] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[i][7] == 0){
				count=3;
			}
			if(count == 2 && State[i][7] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[i][0]=hyoka[i][0]+100;
				break;
			}
		}
		count = 0;
		for(i=6; i>=1; i--){
			if(count == 0 && State[7][7] == Turn){
				count=1;
			}
			if(count == 1 && State[i][7] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[i][7] == 0){
				count=3;
			}
			if(count == 2 && State[i][7] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[i][7]=hyoka[i][7]+100;
				break;
			}
		}
		count = 0;
		for(i=6; i>=1; i--){
			if(count == 0 && State[7][7] == Turn){
				count=1;
			}
			if(count == 1 && State[7][i] == Turn*(-1)){
				count=2;
			}
			if(count != 0 && State[7][i] == 0){
				count=3;
			}
			if(count == 2 && State[7][i] == Turn){
				count=0;
			}
			if(count == 3){
				hyoka[7][i]=hyoka[7][i]+100;
				break;
			}
		}
		count = 0;
		for(i=0; i<SIZE; i++){
			if(State[0][i]!=0){
				count++;
			}
			else{count=0;}
			if(count>=3){
				hyoka[1][i-1] = hyoka[1][i-1]+50;
			}
		}
		count = 0;
		for(i=0; i<SIZE; i++){
			if(State[i][0]!=0){
				count++;
			}
			else{count=0;}
			if(count>=3){
				hyoka[i-1][1] = hyoka[i-1][1]+50;
			}
		}
		count = 0;
		for(i=0; i<SIZE; i++){
			if(State[7][i]!=0){
				count++;
			}
			else{count=0;}
			if(count>=3){
				hyoka[6][i-1] = hyoka[6][i-1]+50;
			}
		}
		count = 0;
		for(i=0; i<SIZE; i++){
			if(State[i][7]!=0){
				count++;
			}
			else{count=0;}
			if(count>=3){
				hyoka[i-1][6] = hyoka[i-1][6]+50;
			}
		}
		for(i=2; i<=6; i++){
			if(State[0][1] !=0 || State[0][i] != Turn*(-1) || State[0][7] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[1][1] = hyoka[1][1]+200;
		}
		for(i=2; i<=6; i++){
			if(State[0][0] !=Turn*(-1)|| State[0][1] !=0 || State[0][i] != Turn*(-1) || State[0][7] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[0][1] = hyoka[0][1]+100;
		}
		for(i=1; i<=5; i++){
			if(State[0][6] !=0 || State[0][i] != Turn*(-1) || State[0][0] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[1][6] = hyoka[1][6]+200;
		}
		for(i=1; i<=5; i++){
			if(State[0][7] !=Turn*(-1) || State[0][6] !=0 || State[0][i] != Turn*(-1) || State[0][0] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[0][6] = hyoka[0][6]+100;
		}
		for(i=2; i<=6; i++){
			if(State[7][1] !=0 || State[7][i] != Turn*(-1) || State[7][7] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[6][1] = hyoka[6][1]+200;
		}
		for(i=2; i<=6; i++){
			if(State[7][0] != Turn*(-1) || State[7][1] !=0 || State[7][i] != Turn*(-1) || State[7][7] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[7][1] = hyoka[7][1]+100;
		}
		for(i=1; i<=5; i++){
			if(State[7][6] !=0 || State[7][i] != Turn*(-1) || State[7][0] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[6][6] = hyoka[6][6]+200;
		}
		for(i=1; i<=5; i++){
			if(State[7][7] != Turn*(-1) || State[7][6] !=0 || State[7][i] != Turn*(-1) || State[7][0] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[7][6] = hyoka[7][6]+100;
		}
		for(i=2; i<=6; i++){
			if(State[1][0] !=0 || State[i][0] != Turn*(-1) || State[7][0] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[1][1] = hyoka[1][1]+200;
		}
		for(i=2; i<=6; i++){
			if(State[0][0] != Turn*(-1) || State[1][0] !=0 || State[i][0] != Turn*(-1) || State[7][0] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[1][0] = hyoka[1][0]+100;
		}
		for(i=1; i<=5; i++){
			if(State[6][0] !=0 || State[i][0] != Turn*(-1) || State[0][0] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[6][1] = hyoka[6][1]+200;
		}
		for(i=1; i<=5; i++){
			if(State[7][0] != Turn*(-1) || State[6][0] !=0 || State[i][0] != Turn*(-1) || State[0][0] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[6][0] = hyoka[6][0]+100;
		}
		for(i=2; i<=6; i++){
			if(State[1][7] !=0 || State[i][7] != Turn*(-1) || State[7][7] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[1][6] = hyoka[1][6]+200;
		}
		for(i=2; i<=6; i++){
			if(State[0][7] != Turn*(-1) || State[1][7] !=0 || State[i][7] != Turn*(-1) || State[7][7] != 0){
				break;
			}
		}
		if(i == 7){
			hyoka[1][7] = hyoka[1][7]+100;
		}
		for(i=1; i<=5; i++){
			if(State[6][7] !=0 || State[i][7] != Turn*(-1) || State[0][7] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[6][6] = hyoka[6][6]+200;
		}
		for(i=1; i<=5; i++){
			if(State[7][7] != Turn*(-1) || State[6][7] !=0 || State[i][7] != Turn*(-1) || State[0][7] != 0){
				break;
			}
		}
		if(i == 6){
			hyoka[6][7] = hyoka[6][7]+100;
		}
		if(State[0][0] != 0){
			hyoka[1][0] = hyoka[1][0]+80;
			hyoka[0][1] = hyoka[0][1]+80;
			hyoka[1][1] = hyoka[1][1]+80;
		}
		if(State[0][7] != 0){
			hyoka[0][6] = hyoka[0][6]+80;
			hyoka[1][7] = hyoka[1][7]+80;
			hyoka[1][6] = hyoka[1][6]+80;
		}
		if(State[7][0] != 0){
			hyoka[6][0] = hyoka[6][0]+80;
			hyoka[7][1] = hyoka[7][1]+80;
			hyoka[6][1] = hyoka[6][1]+80;
		}
		if(State[7][7] != 0){
			hyoka[6][7] = hyoka[6][7]+80;
			hyoka[7][6] = hyoka[7][6]+80;
			hyoka[6][6] = hyoka[6][6]+80;
		}
		min = 100; num = 0; max = 0; hyokamax = -100;
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j, NULL);
				if( hyoka[i][j] == hyokamax && num >= 1){
					list[count].x = i; list[count].y = j;
					list[count].get = num;
					count++;
				}
				if( hyoka[i][j] > hyokamax && num >= 1){
					count=0;
					list[count].x = i; list[count].y = j;
					list[count].get = num;
					hyokamax = hyoka[i][j];
					count++;
				}
				if( num >= max ){
					max = num;
				}
			}
		}
		if(count!=0){
			srand((unsigned)time(NULL));
			n=rand()%count;
			p.x=list[n].x; p.y=list[n].y; p.get=list[n].get;
		}
		if(max == 0){
			p.x = -1;
			p.y = -1;
			p.get = 0;
		}
		for(k=0; k<=30; k++){
			list[k].x=0; list[k].y=0; list[k].get=0;
		}
	}
	if(his_no>=59){
		k=0;
		for(i=0; i<SIZE; i++){
			for(j=0; j<SIZE; j++){
				num = Num_of_othello(State, Turn, i,j,NULL);
				if( num > 0 ){
					/* 1łƂꏊƐׂċLĂ */
					one[k].x = i; one[k].y = j;
					one[k].get = num;
					k++;
				}
			}
		}

		/* ǂɒuĂƂȂꍇ */
		/* (ƂꏊSۑĂȂꍇ k0̂܂) */
		if(k == 0){
			p.x = -1;
			p.y = -1;
			p.get = 0;
			return p;
		}


		/* 2ڂǂ
	  	 ͒PɈԂƂƂė
	   	Ɖ肷 */
		min = 100; /* ŏl100ɂĂ */
		/* SĂ1(ĹBkނ)ɕtčl */
		for(i=0; i<k; i++){
			int **PseudoState1; /* 1ڂ̏Ԃ߂Ƃ̃|C^ */
			int PState1[SIZE][SIZE]; /* 1ڂł̏Ԃێ */
			int tr = Turn;     /* ǂ݂Ƃ̎ԕϐ */
			int x, y;
			Pos p1;  /* 肪łėꏊ */

			x = one[i].x;
			y = one[i].y;
			/* 1ڂł */
			/* ł̔Ֆʂ */
			PseudoState1 = Put_othello(State, tr, x,y);
			PseudoState1[x][y] = tr;
			/* Rs[ */
			CopyState(PseudoState1, PState1);
			/* Rs[Rs[͔j */
			freeState(PseudoState1);
			/* ^[ς */
			tr *= -1;

			/* 1ڂł̏Ԃ
		 	  łƂT
		  	 (̔) */
			p1 = GetMax(PState1, tr);

			/* 肪鐔菭Ȃ
		 	  ̂Ƃ1ڂ̗p */
			if(p1.get < min){ 
				p.x = x;
				p.y = y;
				p.get = one[i].get;
				min = p1.get;
			} else
				/* 肪鐔ꏏȂ
		   		炪葽قI */
			if(p1.get == min && p.get < one[i].get){
				p.x = x;
				p.y = y;
				p.get = one[i].get;
			}
		}
	}
	return p;
}

static Pos GetMax(int PState[][SIZE], int tr)
{
	int i,j;
	int num; /* 鐔 */
	int max; /* ől */
	Pos p;   /* Ԃꏊ */

	max = 0;
	for(i=0; i<SIZE; i++){
		for(j=0; j<SIZE; j++){
			num = Num_of_othello(PState, tr, i, j, NULL);
			if(num >= max){
				max = num;
				p.x = i;
				p.y = j;
				p.get = max;
			}
		}
	}

	/* ǂȂꍇ(-1,-1)Ԃ */
	if(max == 0){
		p.x = -1;
		p.y = -1;
		p.get = 0;
	}

	return p;
}
