
#include <stdio.h>
#include <stdlib.h>

Pos think(int st[][SIZE], int, int, int, int);

Pos think(int State[][SIZE], int Self, int Turn, int Depth, int Range)
{
  Pos one[SIZE*SIZE];
  int i, j, n = 0;

  int x, y;
  int **PseudoState;
  int PState[SIZE][SIZE];
  Pos p = {-1, -1};
  Pos rp = p;

  Depth ++;
  if (Depth >= Range)
    return score (State, Turn);

  // first phase
  for (i=0; i<SIZE; i++)
      for (j=0; j<SIZE; j++)
	  if (Num_of_othello (State, Turn, i, j, NULL) > 0)
	    {
	      one[n].x = i;
	      one[n].y = j;
	      one[n].get = 0;
	      n ++;
	    }

  if (Self == Turn)
    rp.get = 10000;
  else
    rp.get = 0;

  for (i=0; i<n; i++)
    {
      x = one[i].x;
      y = one[i].y;
      // put 1
      PseudoState = Put_othello (State, Turn, x, y);
      PseudoState[x][y] = Turn;
      CopyState (PseudoState, PState);
      freeState (PseudoState);

      p = think (PState, Self, -Turn, Depth, Range);
      // p = mini-max value
      if (Self == Turn)
	{
	  if (p.get < rp.get)
	    {
	      rp.x = x;
	      rp.y = y;
	      rp.get = p.get;
	    }
	}
      else
	{
	  if (p.get > rp.get)
	    {
	      rp.x = x;
	      rp.y = y;
	      rp.get = p.get;
	    }
	}
    }

  return rp;
}
